package de.java2html.eclipse.popup;

import org.eclipse.jface.action.IAction;
import org.eclipse.jface.text.ITextSelection;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.ui.IEditorActionDelegate;
import org.eclipse.ui.IEditorPart;

import de.java2html.eclipse.util.ReadableDocument;
import de.java2html.eclipse.util.ReadableDocumentStringAdapter;

/**
 * @author Markus Gebhard
 */
public class Java2HtmlEditorPopupAction extends AbstractJava2HtmlAction implements IEditorActionDelegate {

  private IEditorPart activeEditorPart;

  protected JavaDocumentList getDocumentList() {
    if (activeEditorPart == null) {
      return null;
    }
    ISelection selection = activeEditorPart.getEditorSite().getSelectionProvider().getSelection();
    if (!(selection instanceof ITextSelection)) {
      return null;
    }

    String text = ((ITextSelection) selection).getText();
    if (text == null || text.length() == 0) {
      return null;
    }

    JavaDocumentList documents = new JavaDocumentList();
    ReadableDocument document = new ReadableDocumentStringAdapter(text);
    document.setName(activeEditorPart.getTitle());
    documents.add(document);
    documents.setName(activeEditorPart.getTitle());
    return documents;
  }

  public void setActiveEditor(IAction action, IEditorPart targetEditor) {
    activeEditorPart = targetEditor;
    setActivePart(action, targetEditor);
  }
}